---
title: <textarea>
slug: Web/HTML/Element/textarea
tags:
  - Element
  - Forms
  - HTML
  - HTML forms
  - Reference
  - Web
  - textarea
---
<div>{{HTMLRef}}</div>

<p>The <strong>HTML <code>&lt;textarea&gt;</code> element</strong> represents a multi-line plain-text editing control, useful when you want to allow users to enter a sizeable amount of free-form text, for example a comment on a review or feedback form.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/textarea.html", "tabbed-standard")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</p>

<p>The above example demonstrates a number of features of <code>&lt;textarea&gt;</code>:</p>

<ul>
 <li>An <code>id</code> attribute to allow the <code>&lt;textarea&gt;</code> to be associated with a {{htmlelement("label")}} element for accessibility purposes</li>
 <li>A <code>name</code> attribute to set the name of the associated data point submitted to the server when the form is submitted.</li>
 <li><code>rows</code> and <code>cols</code> attributes to allow you to specify an exact size for the <code>&lt;textarea&gt;</code> to take. Setting these is a good idea for consistency, as browser defaults can differ.</li>
 <li>Default content entered between the opening and closing tags. <code>&lt;textarea&gt;</code> does not support the <code>value</code> attribute.</li>
</ul>

<p>The <code>&lt;textarea&gt;</code> element also accepts several attributes common to form <code>&lt;input&gt;</code>s, such as <code>autocomplete</code>, <code>autofocus</code>, <code>disabled</code>, <code>placeholder</code>, <code>readonly</code>, and <code>required</code>.</p>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("autocapitalize")}} {{non-standard_inline}}</dt>
 <dd>This is a non-standard attribute supported by WebKit on iOS (therefore nearly all browsers running on iOS, including Safari, Firefox, and Chrome), which controls whether and how the text value should be automatically capitalized as it is entered/edited by the user. The non-deprecated values are available in iOS 5 and later. Possible values are:
 <ul>
  <li><code>none</code>: Completely disables automatic capitalization.</li>
  <li><code>sentences</code>: Automatically capitalize the first letter of sentences.</li>
  <li><code>words</code>: Automatically capitalize the first letter of words.</li>
  <li><code>characters</code>: Automatically capitalize all characters.</li>
  <li><code>on</code>: {{deprecated_inline()}} Deprecated since iOS 5.</li>
  <li><code>off</code>: {{deprecated_inline()}} Deprecated since iOS 5.</li>
 </ul>
 </dd>
 <dt>{{htmlattrdef("autocomplete")}}</dt>
 <dd>This attribute indicates whether the value of the control can be automatically completed by the browser. Possible values are:
 <ul>
  <li><code>off</code>: The user must explicitly enter a value into this field for every use, or the document provides its own auto-completion method; the browser does not automatically complete the entry.</li>
  <li><code>on</code>: The browser can automatically complete the value based on values that the user has entered during previous uses.</li>
 </ul>

 <p>If the <code>autocomplete</code> attribute is not specified on a <code>&lt;textarea&gt;</code> element, then the browser uses the <code>autocomplete</code> attribute value of the <code>&lt;textarea&gt;</code> element's form owner. The form owner is either the {{HTMLElement("form")}} element that this <code>&lt;textarea&gt;</code> element is a descendant of or the form element whose <code>id</code> is specified by the <code>form</code> attribute of the input element. For more information, see the {{htmlattrxref("autocomplete", "form")}} attribute in {{HTMLElement("form")}}.</p>
 </dd>
 <dt>{{ htmlattrdef("autofocus") }}</dt>
 <dd>This Boolean attribute lets you specify that a form control should have input focus when the page loads. Only one form-associated element in a document can have this attribute specified.</dd>
 <dt>{{ htmlattrdef("cols") }}</dt>
 <dd>The visible width of the text control, in average character widths. If it is specified, it must be a positive integer. If it is not specified, the default value is <code>20</code>.</dd>
 <dt>{{ htmlattrdef("disabled") }}</dt>
 <dd>This Boolean attribute indicates that the user cannot interact with the control. If this attribute is not specified, the control inherits its setting from the containing element, for example {{ HTMLElement("fieldset") }}; if there is no containing element when the <code>disabled</code> attribute is set, the control is enabled.</dd>
 <dt>{{ htmlattrdef("form") }}</dt>
 <dd>The form element that the <code>&lt;textarea&gt;</code> element is associated with (its "form owner"). The value of the attribute must be the <code>id</code> of a form element in the same document. If this attribute is not specified, the <code>&lt;textarea&gt;</code> element must be a descendant of a form element. This attribute enables you to place <code>&lt;textarea&gt;</code> elements anywhere within a document, not just as descendants of form elements.</dd>
 <dt>{{ htmlattrdef("maxlength") }}</dt>
 <dd>The maximum number of characters (UTF-16 code units) that the user can enter. If this value isn't specified, the user can enter an unlimited number of characters.</dd>
 <dt>{{ htmlattrdef("minlength") }}</dt>
 <dd>The minimum number of characters (UTF-16 code units) required that the user should enter.</dd>
 <dt>{{ htmlattrdef("name") }}</dt>
 <dd>The name of the control.</dd>
 <dt>{{ htmlattrdef("placeholder") }}</dt>
 <dd>A hint to the user of what can be entered in the control. Carriage returns or line-feeds within the placeholder text must be treated as line breaks when rendering the hint.
 <div class="note"><strong>Note:</strong> Placeholders should only be used to show an example of the type of data that should be entered into a form; they are <em>not</em> a substitute for a proper {{HTMLElement("label")}} element tied to the input. See {{SectionOnPage("/en-US/docs/Web/HTML/Element/input", "Labels and placeholders")}} for a full explanation.</div>
 </dd>
 <dt>{{ htmlattrdef("readonly") }}</dt>
 <dd>This Boolean attribute indicates that the user cannot modify the value of the control. Unlike the <code>disabled</code> attribute, the <code>readonly</code> attribute does not prevent the user from clicking or selecting in the control. The value of a read-only control is still submitted with the form.</dd>
 <dt>{{ htmlattrdef("required") }}</dt>
 <dd>This attribute specifies that the user must fill in a value before submitting a form.</dd>
 <dt>{{ htmlattrdef("rows") }}</dt>
 <dd>The number of visible text lines for the control.</dd>
 <dt>{{ htmlattrdef("spellcheck") }}</dt>
 <dd>Specifies whether the <code>&lt;textarea&gt;</code> is subject to spell checking by the underlying browser/OS. The value can be:
 <ul>
  <li><code>true</code>: Indicates that the element needs to have its spelling and grammar checked.</li>
  <li><code>default</code> : Indicates that the element is to act according to a default behavior, possibly based on the parent element's own <code>spellcheck</code> value.</li>
  <li><code>false</code> : Indicates that the element should not be spell checked.</li>
 </ul>
 </dd>
 <dt>{{ htmlattrdef("wrap") }}</dt>
 <dd>Indicates how the control wraps text. Possible values are:
 <ul>
  <li><code>hard</code>: The browser automatically inserts line breaks (CR+LF) so that each line has no more than the width of the control; the <code>cols</code> attribute must also be specified for this to take effect.</li>
  <li><code>soft</code>: The browser ensures that all line breaks in the value consist of a CR+LF pair, but does not insert any additional line breaks.</li>
  <li><code>off</code> {{non-standard_inline}}: Like <code>soft</code> but changes appearance to <code>white-space: pre</code> so line segments exceeding <code>cols</code> are not wrapped and the <code>&lt;textarea&gt;</code> becomes horizontally scrollable.</li>
 </ul>

 <p>If this attribute is not specified, <code>soft</code> is its default value.</p>
 </dd>
</dl>

<h2 id="Styling_with_CSS">Styling with CSS</h2>

<p><code>&lt;textarea&gt;</code> is a <a href="/en-US/docs/Web/CSS/Replaced_element">replaced element</a> — it has intrinsic dimensions, like a raster image. By default, its {{cssxref("display")}} value is block. Compared to other form elements it is relatively easy to style, with its box model, fonts, color scheme, etc. being easily manipulable using regular CSS.</p>

<p><a href="/en-US/docs/Learn/Forms/Styling_web_forms">Styling HTML forms</a> provides some useful tips on styling <code>&lt;textarea&gt;</code>s.</p>

<h3 id="Baseline_inconsistency">Baseline inconsistency</h3>

<p>The HTML specification doesn't define where the baseline of a <code>&lt;textarea&gt;</code> is, so different browsers set it to different positions. For Gecko, the <code>&lt;textarea&gt;</code> baseline is set on the baseline of the first line of the textarea, on another browser it may be set on the bottom of the <code>&lt;textarea&gt;</code> box. Don't use {{cssxref("vertical-align")}}<code>: baseline</code> on it; the behavior is unpredictable.</p>

<h3 id="Controlling_whether_a_textarea_is_resizable">Controlling whether a textarea is resizable</h3>

<p>In most browsers, <code>&lt;textarea&gt;</code>s are resizable — you'll notice the drag handle in the right hand corner, which can be used to alter the size of the element on the page. This is controlled by the {{ cssxref("resize") }} CSS property — resizing is enabled by default, but you can explicitly disable it using a <code>resize</code> value of <code>none</code>:</p>

<pre class="brush: html notranslate">textarea {
  resize: none;
}
</pre>

<h3 id="Styling_valid_and_invalid_values">Styling valid and invalid values</h3>

<p>Valid and invalid values of a <code>&lt;textarea&gt;</code> element (e.g. those within, and outside the bounds set by <code>minlength</code>, <code>maxlength</code>, or <code>required</code>) can be highlighted using the {{cssxref(":valid")}} and {{cssxref(":invalid")}} pseudo-classes. For example, to give your textarea a different border depending on whether it is valid or invalid:</p>

<pre class="brush: css notranslate">textarea:invalid {
  border: 2px dashed red;
}

textarea:valid {
   border: 2px solid lime;
}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>The following example show a very simple textarea, with a set numbers of rows and columns and some default content.</p>

<pre class="brush: html notranslate">&lt;textarea name="textarea"
   rows="10" cols="50"&gt;Write something here&lt;/textarea&gt;</pre>

<p>{{ EmbedLiveSample('Basic_example','600','150') }}</p>

<h3 id="Min_and_max_length">Min and max length</h3>

<p>This example has a minimum and maximum number of characters — of 10 and 20 respectively. Try it and see.</p>

<pre class="brush: html notranslate">&lt;textarea name="textarea"
   rows="5" cols="30"
   minlength="10" maxlength="20"&gt;Write something here&lt;/textarea&gt;</pre>

<p>{{ EmbedLiveSample('Min_and_max_length','600','80') }}</p>

<p>Note that <code>minlength</code> doesn't stop the user from removing characters so that the number entered goes past the minimum, but it does make the value entered into the <code>&lt;textarea&gt;</code> invalid. Also note that even if you have a <code>minlength</code> value set (3, for example), an empty <code>&lt;textarea&gt;</code> is still considered valid unless you also have the <code>required</code> attribute set.</p>

<h3 id="Placeholder">Placeholder</h3>

<p>This example has a placeholder set. Notice how it disappears when you start typing into the box.</p>

<pre class="brush: html notranslate">&lt;textarea name="textarea"
   rows="5" cols="30"
   placeholder="Comment text."&gt;&lt;/textarea&gt;</pre>

<p>{{ EmbedLiveSample('Placeholder','600','80') }}</p>

<div class="note">
<p><strong>Note:</strong> Placeholders should only be used to show an example of the type of data that should be entered into a form; they are <em>not</em> a substitute for a proper {{HTMLElement("label")}} element tied to the input. See {{SectionOnPage("/en-US/docs/Web/HTML/Element/input", "Labels and placeholders")}} for a full explanation.</p>
</div>

<h3 id="Disabled_and_readonly">Disabled and readonly</h3>

<p>This example shows two <code>&lt;textarea&gt;</code>s — one of which is <code>disabled</code>, and one of which is <code>readonly</code>. Have a play with both and you'll see the difference in behavior — the <code>disabled</code> element is not selectable in any way (and its value is not submitted), whereas the <code>readonly</code> element is selectable and its contents copyable (and its value is submitted); you just can't edit the contents.</p>

<div class="note">
<p><strong>Note:</strong> In browsers other than firefox, such as chrome, the <code>disabled</code> textarea content may be selectable and copyable.</p>
</div>

<pre class="brush: html notranslate">&lt;textarea name="textarea"
   rows="5" cols="30"
   disabled&gt;I am a disabled textarea&lt;/textarea&gt;
&lt;textarea name="textarea"
   rows="5" cols="30"
   readonly&gt;I am a readonly textarea&lt;/textarea&gt;
</pre>

<p>{{ EmbedLiveSample('Disabled_and_readonly','600','80') }}</p>

<h2 id="Technical_summary">Technical summary</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Interactive_content">Interactive content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form_listed">listed</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form_labelable">labelable</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#form_resettable">resettable</a>, and <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form_submittable">submittable</a> <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form-associated_">form-associated</a> element.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>Text</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/textbox_role">textbox</a></code></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLTextAreaElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#the-textarea-element', '&lt;textarea&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'sec-forms.html#the-textarea-element', '&lt;textarea&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML4.01', 'interact/forms.html#h-17.7', '&lt;textarea&gt;')}}</td>
   <td>{{Spec2('HTML4.01')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.textarea")}}</p>

<h2 id="See_also">See also</h2>

<p>Other form-related elements:</p>

<ul>
 <li>{{ HTMLElement("form") }}</li>
 <li>{{ HTMLElement("button") }}</li>
 <li>{{ HTMLElement("datalist") }}</li>
 <li>{{ HTMLElement("legend") }}</li>
 <li>{{ HTMLElement("label") }}</li>
 <li>{{ HTMLElement("select") }}</li>
 <li>{{ HTMLElement("optgroup") }}</li>
 <li>{{ HTMLElement("option") }}</li>
 <li>{{ HTMLElement("input") }}</li>
 <li>{{ HTMLElement("keygen") }}</li>
 <li>{{ HTMLElement("fieldset") }}</li>
 <li>{{ HTMLElement("output") }}</li>
 <li>{{ HTMLElement("progress") }}</li>
 <li>{{ HTMLElement("meter") }}</li>
</ul>
